stages:
  - build
  - test
  - build docker image
  - deploy

image: maven

compile: 
  script: "mvn -D maven.test.skip=true package" 
  stage: build
  artifacts: 
    paths: 
      - target/sales-system-0.1.0.jar

test:
  script: "mvn test"
  stage: test

build image:
  dependencies: 
    - compile
  services: 
    - docker:dind
  image: docker:stable
  stage: build docker image 
  script: 
    - docker build -t registry.gitlab.com/knowledge21/csd201809boca/sales-system .
    - docker login -u=$CI_REGISTRY_USER -p=$CI_REGISTRY_PASSWORD registry.gitlab.com
    - docker push registry.gitlab.com/knowledge21/csd201809boca/sales-system

deploy image:
  stage: deploy
  when: manual
  before_script:
    - mkdir -p ~/.ssh
    - echo "$DEPLOY_SERVER_PRIVATE_KEY" | tr -d '\r' > ~/.ssh/id_rsa
    - chmod 600 ~/.ssh/id_rsa
    - eval "$(ssh-agent -s)"
    - ssh-add ~/.ssh/id_rsa
    - ssh-keyscan -H $DEPLOYMENT_SERVER_IP >> ~/.ssh/known_hosts
  script:  
    - ssh $DEPLOYMENT_SERVER_USER@$DEPLOYMENT_SERVER_IP "docker login -u=$CI_REGISTRY_USER -p=$CI_REGISTRY_PASSWORD registry.gitlab.com && docker run -d -p 8080:8080 registry.gitlab.com/knowledge21/csd201809boca/sales-system" 
